package as.adamsmith.etherealdialpad;

import android.content.Context;
import android.os.Bundle;
import android.os.RemoteException;
import android.view.MotionEvent;
import android.view.SurfaceView;

public class BasicPad extends Pad {	
	FlatView flatView;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		flatView = new FlatView(this);
		setContentView(flatView);
	}
	
	class FlatView extends SurfaceView {

		public FlatView(Context context) {
			super(context);
			setBackgroundColor(0xFF404040);
		}
		
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			final float u = Math.min(1, Math.max(0,event.getX() / getWidth()));
			final float v = Math.min(1, Math.max(0,1.0f - event.getY() / getHeight()));
			
			
			if(event.getAction() == MotionEvent.ACTION_UP) {

				try {
					synthService.primaryOff();
					synthService.primaryXY(u, v);
				} catch (RemoteException e) {
					e.printStackTrace();
				}
				
				setBackgroundColor(0xFF404040);
				invalidate();
				
			} else {
				if(event.getAction() == MotionEvent.ACTION_DOWN) {
					try {
						synthService.primaryOn();
						synthService.primaryXY(u, v);
					} catch (RemoteException e) {
						e.printStackTrace();
					}
				} else if(event.getAction() == MotionEvent.ACTION_MOVE) {
					
					try {
						synthService.primaryXY(u, v);
					} catch (RemoteException e) {
						e.printStackTrace();
					}
				}
				
				int r = (int)( 128+128*(u-0.5f) );
				int g = (int)( 128+128*(v-0.5f) );
				int b = (int)( 128+128*(0.5f-u) );
				setBackgroundColor(0xFF000000 | (r<<16) | (g<<8)| b);
				invalidate();
			}
			
			return true;
		}
		
	}
}
