package as.adamsmith.etherealdialpad;

import java.lang.reflect.*;

public class BuildChecker {
	public static boolean isHoneycombOrBetter() {
		try {
			Class<?> version = Class.forName("android.os.Build$VERSION");
			Field sdk_intField = version.getField("SDK_INT");
			int sdk_int = sdk_intField.getInt(null);
			Class<?> versionCodes = Class.forName("android.os.Build$VERSION_CODES");
			Field honeycombField = versionCodes.getField("HONEYCOMB");
			int honeycomb = honeycombField.getInt(null);
			return sdk_int >= honeycomb;
		} catch (Exception e) {
			return false;
		}
		
	}
}
